unit unit_lab1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
  data : array [0..3, 0..5] of real = ((-0.0005, -0.0008, 0.00095, -0.001, -0.001, -0.001),
                              (-0.001, -0.0012, -0.0016, -0.0019, -0.002, -0.0021),
                              (-0.0012, -0.0018, -0.0022, -0.0026, -0.0028, -0.0029),
                              (-0.0013, -0.002, -0.0026, -0.00295, -0.0032, -0.0033));
  alpha : array [0..3] of real = (0, 6, 9, 13);
  M : array [0..5] of real = (0, 0.2, 0.4, 0.6, 0.8, 1);

type

  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

function getIndex (data : array of real; value : real) : integer;
function inter (x0, y0, x1, y1, x : real) : real;

implementation

{$R *.dfm}

function getIndex (data : array of real; value : real) : integer;
  var i, index : integer;
  begin
    index := -1;
    for i := 0 to length(data) - 2 do
      if ((value >= data[i]) and (value <= data[i + 1])) then
      begin
          index := i;
          break;
      end;
    result := index;
  end;

function inter (x0, y0, x1, y1, x : real) : real;
  begin
    result := (y1 - y0) / (x1 - x0) * (x - x0) + y0; // y=kx+b=k(x-x0)+y0
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin



  Label1.Caption := FloatToStr(getIndex(alpha, 0.5));
end;


procedure TForm1.Button1Click(Sender: TObject);
var newM, newAlpha, newResult, result0, result1 : real;
    MInt, AlphaInt : integer;
begin

  try

  newM := StrToFloat(Edit1.Text);
  newAlpha := StrToFloat(Edit2.Text);
  MInt := getIndex(M, newM);
  AlphaInt := getIndex(Alpha, newAlpha);

  if (MInt = -1) or (AlphaInt = -1) then
    begin
      Label1.Caption := '!!!      . !';
    end
  else
    begin
      result0 := inter(alpha[AlphaInt], data[AlphaInt, MInt],
                      alpha[AlphaInt + 1], data[AlphaInt + 1, MInt], newAlpha);
      result1 := inter(alpha[AlphaInt], data[AlphaInt, MInt + 1],
                      alpha[AlphaInt + 1], data[AlphaInt + 1, MInt + 1], newAlpha);
      newResult := inter(M[MInt], result0,
                      M[MInt + 1], result1, newM);
      Label1.Caption := ': '+FloatToStr(newResult);
    end;

    except
      on Exception do
        Label1.Caption := ' -  !';
    end;
end;

end.
